using System.Globalization;
using System.Web;
using System.Web.Compilation;

namespace MvcLocalization
{
    public class WebFormResourceHelper : ResourceHelper
    {
        public WebFormResourceHelper(string virtualPath)
        {
            VirtualPath = virtualPath;
        }

        public string VirtualPath { get; private set; }

        public override string GetString(string expression, params object[] args)
        {
            ResourceExpressionFields fields = GetResourceFields(expression, VirtualPath);
            if (!string.IsNullOrEmpty(fields.ClassKey))
                return GetGlobalResource(fields, args);

            return string.Format((string) HttpContext.GetLocalResourceObject(VirtualPath, fields.ResourceKey, CultureInfo.CurrentUICulture), args);
        }
    }
}